﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace KV6ToPNG
{
    public class Point
    {
        public Point()
        {
            RGBA = 0x00ffffff;
            SurfaceFlag = 0x40;//0x40 air 0x80 Interior
        }

        public Point(int r, int g, int b, int flag, int x, int y, int z)
        {
            RGBA = r + (g << 8) + (b << 16) + (255 << 24);
            SurfaceFlag = flag;
            this.x = x;
            this.y = y;
            this.z = z;
        }

        public Point(int rgba, int flag, int x, int y, int z)
        {
            RGBA = rgba;
            SurfaceFlag = flag;
            this.x = x;
            this.y = y;
            this.z = z;
        }

        public Point(Point point)
        {
            this.RGBA = point.RGBA;
            this.SurfaceFlag = point.SurfaceFlag;
            this.x = point.x;
            this.y = point.y;
            this.z = point.z;
        }

        public override string ToString()
        {
            return "" + x + "," + y + "," + z + "    " + Convert.ToString(SurfaceFlag, 2);
        }

        public int RGBA, SurfaceFlag;//0xff Empty Space 0xffffff Normal

        public bool IsAir { get { return (SurfaceFlag & 0x40) != 0; } }
        public bool IsSolid { get { return (SurfaceFlag & 0x40) == 0; } }
        public bool IsEdge { get { return (SurfaceFlag & 0x3f) != 0; } }

        public int x, y, z;
        public int VoxNormal;//not used except for voxel conversions
    }
}
