﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace KV6ToPNG
{
    public class Ring : List<Position>
    {
        public Ring()
        {
            Connections = new List<RingConnection>();
        }

        public List<RingConnection> Connections;
        int currentConnection = 0;

        public RingConnection GetNextConnection()
        {
            if (Connections.Count == 0)
                return null;
            currentConnection++;
            currentConnection = currentConnection % Connections.Count;
            return Connections[currentConnection];
        }

        public RingConnection GetPreviousConnection()
        {
            if (Connections.Count == 0)
                return null;
            currentConnection--;
            if (currentConnection <= 0) currentConnection += Connections.Count;
            return Connections[currentConnection];
        }


        public Position FindConnection(Ring otherRing)
        {
            foreach (Position p1 in this)
                foreach (Position p2 in otherRing)
                {
                    if (p1.x == p2.x && p1.y == p2.y && p1.z == p2.z)
                    {
                        return p1;
                    }
                }
            return null;
        }
    }
}
